/*
 * PokeFrog - A 'Pokemonized' verison of Frogger, the well-known Konami game.
 *
 * copyright (c) 2012 Fabien LOISON <http://www.flogisoft.com/>
 * 
 * this program is free software. it comes without any warranty, to
 * the extent permitted by applicable law. you can redistribute it
 * and/or modify it under the terms of the do what the fuck you want
 * to public license, version 2, as published by sam hocevar. see
 * http://sam.zoy.org/wtfpl/copying for more details. 
 */


/**
 * @module PokeFrog
 */


/**
 * The finish screen (win or game over)
 *
 * @class Player
 * @constructor
 *
 * @param {Image} The image that will be blitted on the canvas.
 * @param {Function} callback The callback function that will be called after
 *        the finish screen.
 */
function FinishScreen(image, callback)
{
	this._image = image;
	this._callback = callback;

	this._duration = 180;  // 60 = 1s (@ 60Hz)
	this._x = wjs.canvas.width;
}

/**
 * Draw the finish screen on the canvas.
 *
 * @method draw
 */
FinishScreen.prototype.draw = function()
{
	// Screen come in
	if (this._x > (wjs.canvas.width - this._image.width) / 2 && this._duration > 0)
	{
		this._x -= 5;
	}
	// Wait
	else if (this._duration > 0)
	{
		this._duration -= 1;
	}
	// Screen go out
	else if (this._x > -this._image.width)
	{
		this._x -= 5;
	}
	// Callback
	else
	{
		this._callback();
	}
	var y = Math.floor((wjs.canvas.height - this._image.height) / 2);

	var ctx = wjs.canvas.getContext('2d');

	var bgImage = wjs.loader.getImage('finishscreenbg');
	wjs._ctx2d.drawImage(
		bgImage,          // Image
		0,                // Source image x
		0,                // Source image y
		bgImage.width,    // Source width
		bgImage.height,   // Source height
		0,                // Destination canvas x
		0,                // Destination canvas y
		bgImage.width,    // Destination width
		bgImage.height);  // Destination height

	wjs._ctx2d.drawImage(
		this._image,          // Image
		0,                    // Source image x
		0,                    // Source image y
		this._image.width,    // Source width
		this._image.height,   // Source height
		this._x,              // Destination canvas x
		y,                    // Destination canvas y
		this._image.width,    // Destination width
		this._image.height);  // Destination height
}
